.include "m32c-87.inc"

	.section ".vec", "a"
	.long	0		; UND
	.long	0		; overflow
	.long	0		; BRK, see also ivect
	.long	0		; address match
	.long	0		; unused
	.long	0		; watchdog timer
	.long	0		; unused
	.long	0		; NMI

	.section ".resetvec", "a"
	.global	_reset
_reset:
	.long	_start

	.text
	.global _start
_start:
	mov.b	#0xff, pd10
	mov.b	0xaa, p10
	mov.b	0xffffdf, p10
	mov.b	0xffffe3, p10
	mov.b	0xffffeb, p10
	mov.b	0xffffef, p10
	mov.b	0xfffff3, p10
	mov.b	0xfffff7, p10
	mov.b	0xfffffb, p10
	mov.b	#0x55, p10

	fclr	I		; disable interrupts
	fclr	U	/* Interrupt stack gets the big main stack.  */
	ldc	#__stack,sp
; We're going to use a combined stack, because we're running low on memory.
;	fset	U	/* User stack gets the little one. */
;	ldc	#__istack,sp

	ldc	#_ivects,intb

; Copy ROM data to RAM
	mov.l	#__romdatastart,a0
	mov.l	#__datastart,a1
	mov.w	#__romdatacopysize,r3
	shl.w	#-1,r3
	smovf.w

	mov.l	#__bssstart,a1
	mov.w	#__bsssize,r3
	shl.w	#-1,r3
	mov.w	#0,r0
	sstr.w

	fset	I

; Run any function marked as a "contructor"

	mov.l	#__init_array_start, a1
1:	cmp.l	#__init_array_end, a1
	jeq	1f
	pushm	a1
	mov.l	[a1], a0
	jsri.a	a0
	popm	a1
	add.l	#4, a1
	jmp.b	1b
1:	

; Run the main application

	jmp.a	_main

	.global __reset
__reset:
	.global __exit
__exit:
	bset	$prc1, prcr
	bset	$pm03, pm0
	jmp.b	__exit


	.global	_printf
_printf:
	jmp.w	_cprintf
	.bss
	.global	___sf_fake_stdin
___sf_fake_stdin:	
	.global	___sf_fake_stdout
___sf_fake_stdout:	
	.global	___sf_fake_stderr
___sf_fake_stderr:	

	.bss
;	.global	__impure_ptr
;__impure_ptr:
;	.space	10
	.global	mem0
mem0:	.space	1
	.global	mem1
mem1:	.space	1
	.global	mem2
mem2:	.space	1
	.global	mem3
mem3:	.space	1
	.global	mem4
mem4:	.space	1
	.global	mem5
mem5:	.space	1
	.global	mem6
mem6:	.space	1
	.global	mem7
mem7:	.space	1
	.global	mem8
mem8:	.space	1
	.global	mem9
mem9:	.space	1
	.global	mem10
mem10:	.space	1
	.global	mem11
mem11:	.space	1
	.global	mem12
mem12:	.space	1
	.global	mem13
mem13:	.space	1
	.global	mem14
mem14:	.space	1
	.global	mem15
mem15:	.space	1

